Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3445)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3448)
@@ -1,4 +1,4 @@
-!> @file biometeorology.f90
-!------------------------------------------------------------------------------!
+!> @file biometeorology_mod.f90
+!--------------------------------------------------------------------------------!
 ! This file is part of PALM-4U.
 !
@@ -15,10 +15,8 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 2018, Institute of Computer Science,Academy of Sciences, Prague
-!
-! Calculation of PET:
-! Copyright 2016, Deutscher Wetterdienst (DWD) / 
-! German Meteorological Service (DWD)
-!------------------------------------------------------------------------------!
+! Copyright 2018-2018 Deutscher Wetterdienst (DWD)
+! Copyright 2018-2018 Institute of Computer Science, Academy of Sciences, Prague
+! Copyright 2018-2018 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -35,83 +33,446 @@
 ! Authors:
 ! --------
+! @author Dominik Froehlich <dominik.froehlich@dwd.de>
 ! @author Jaroslav Resler <resler@cs.cas.cz>
-! @author Dominik Froehlich <dominik.froehlich@dwd.de>
-!
-!------------------------------------------------------------------------------!
-
-MODULE biometeorology_mod
-!
-!-- Load required variables from existing modules
+!
+!
+! Description:
+! ------------
+!> Human thermal comfort module calculating thermal perception of a sample
+!> human being under the current meteorological conditions.
+!>
+!> @todo Alphabetical sorting of "USE ..." lists, "ONLY" list, variable declarations
+!>       (per subroutine: first all CHARACTERs, then INTEGERs, LOGICALs, REALs, )
+!> @todo Comments start with capital letter --> "!-- Include..." 
+!> @todo Variable and routine names strictly in lowercase letters and in English
+!>
+!> @note nothing now
+!>
+!> @bug  no known bugs by now
+!------------------------------------------------------------------------------!
+ MODULE biometeorology_mod
+
     USE arrays_3d,                                                             &
-        ONLY:  hyp, p, pt, q, u, v, w
+       ONLY:  pt, p, u, v, w, q
+
+    USE averaging,                                                             &
+       ONLY:  pt_av, q_av, u_av, v_av, w_av
 
     USE basic_constants_and_equations_mod,                                     &
-        ONLY:  rd_d_rv
-
-    USE kinds  !< to set precision of INTEGER and REAL arrays according to PALM
-
-    USE radiation_model_mod,  &
-        ONLY: ix, iy, iz, id, mrt_nlevels, mrt_include_sw,                     &
-              mrtinsw, mrtinlw, mrtbl, nmrtbl, radiation
-
-
-    IMPLICIT NONE
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  bio_mrt              !< biometeorology mean radiant temperature for each MRT box
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  bio_mrt_av           !< time average mean radiant temperature for each MRT box
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  bio_pet              !< PhysiologiCALLy Equivalent Temperature (PET) for each MRT box
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  bio_pet_av           !< time average PhysiologiCALLy Equivalent Temperature (PET) for each MRT box
-
-
-    REAL(wp), PARAMETER :: sigma_sb       = 5.67037321E-8_wp,       & !< Stefan-Boltzmann constant
-                           t_zero = -273.15_wp,                     & !< temperature 0K in Celsius
-                           human_absorb = 0.7_wp,                   & !< SW absorbtivity of human body
-                           human_emiss = 0.97_wp                      !< emissivity of human body (Lindberg 2008)
-
-
-    INTERFACE biometeorology_3d_data_averaging
-       MODULE PROCEDURE biometeorology_3d_data_averaging
-    END INTERFACE biometeorology_3d_data_averaging
-
-    INTERFACE biometeorology_check_data_output
-       MODULE PROCEDURE biometeorology_check_data_output
-    END INTERFACE biometeorology_check_data_output
-
-    INTERFACE biometeorology_data_output_3d
-       MODULE PROCEDURE biometeorology_data_output_3d
-    END INTERFACE biometeorology_data_output_3d
-
-    INTERFACE biometeorology_define_netcdf_grid
-       MODULE PROCEDURE biometeorology_define_netcdf_grid
-    END INTERFACE biometeorology_define_netcdf_grid
-
-
-    SAVE
+       ONLY:  magnus
+
+    USE biometeorology_ipt_mod
+
+    USE biometeorology_pet_mod
+
+    USE biometeorology_pt_mod,                                                 &
+       ONLY: calculate_pt_static
+
+    USE biometeorology_utci_mod
+
+    USE control_parameters,                                                    &
+       ONLY:  average_count_3d, biometeorology, dz, dz_stretch_factor,         &
+              dz_stretch_level, humidity, initializing_actions, nz_do3d,       &
+              simulated_time, surface_pressure
+
+    USE grid_variables,                                                        &
+       ONLY:  ddx, dx, ddy, dy
+
+    USE indices,                                                               &
+       ONLY:  nxl, nxr, nys, nyn, nzb, nzt, nys, nyn, nxl, nxr
+
+    USE kinds  !< Set precision of INTEGER and REAL arrays according to PALM
+
+!-- Import radiation model to obtain input for mean radiant temperature
+    USE radiation_model_mod,                                                   &
+       ONLY: ix, iy, iz, id, mrt_nlevels, mrt_include_sw,                      &
+             mrtinsw, mrtinlw, mrtbl, nmrtbl, radiation, rad_sw_in,            &
+             rad_sw_out, rad_lw_in, rad_lw_out
+
+    USE surface_mod,                                                           &
+       ONLY: get_topography_top_index_ji
+
+    IMPLICIT NONE
 
     PRIVATE
 
-!
-!-- Public functions
-    PUBLIC biometeorology_3d_data_averaging, biometeorology_check_data_output, &
-           biometeorology_data_output_3d, biometeorology_define_netcdf_grid
-
-!
-!-- Public variables and constants / NEEDS SORTING
-!   PUBLIC 
-
-
+!-- Declare all global variables within the module (alphabetical order)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_grid  !< tmrt results (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_grid    !< PT results   (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_grid  !< UTCI results (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_grid   !< PET results  (Â°C)
+!-- Grids for averaged thermal indices       
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_av_grid    !< PT results (aver. input)   (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_av_grid  !< UTCI results (aver. input) (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_av_grid   !< PET results (aver. input)  (Â°C)
+!-- Grids for radiation_model
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  biom_mrt     !< biometeorology mean radiant temperature for each MRT box
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  biom_mrt_av  !< time average mean
+
+    INTEGER( iwp ) ::  biom_cell_level     !< cell level biom calculates for
+    REAL ( wp )    ::  biom_output_height  !< height output is calculated in m
+    REAL ( wp )    ::  time_biom_results   !< the time, the last set of biom results have been calculated for
+    REAL ( wp ), PARAMETER ::  cels_offs = 273.15_wp  !< Kelvin-Celsius offset (K)
+    REAL ( wp ), PARAMETER ::  sigma_sb  = 5.67037321E-8_wp  !< Stefan-Boltzmann constant
+    REAL ( wp ), PARAMETER ::  human_absorb = 0.7_wp  !< SW absorbtivity of a human body (Fanger 1972)
+    REAL ( wp ), PARAMETER ::  human_emiss = 0.97_wp  !< LW emissivity of a human body after (Fanger 1972)
+!--
+
+    LOGICAL ::  aver_pt  = .FALSE.  !< switch: do pt averaging in this module? (if .FALSE. this is done globally)
+    LOGICAL ::  aver_q   = .FALSE.  !< switch: do e  averaging in this module?
+    LOGICAL ::  aver_u   = .FALSE.  !< switch: do u  averaging in this module?
+    LOGICAL ::  aver_v   = .FALSE.  !< switch: do v  averaging in this module?
+    LOGICAL ::  aver_w   = .FALSE.  !< switch: do w  averaging in this module?
+    LOGICAL ::  average_trigger_pt   = .FALSE.  !< update averaged input on call to biom_pt?
+    LOGICAL ::  average_trigger_utci = .FALSE.  !< update averaged input on call to biom_utci?
+    LOGICAL ::  average_trigger_pet  = .FALSE.  !< update averaged input on call to biom_pet?
+
+    LOGICAL ::  biom_pt        = .TRUE.   !< Turn index PT (instant. input) on or off
+    LOGICAL ::  biom_pt_av     = .TRUE.   !< Turn index PT (averaged input) on or off
+    LOGICAL ::  biom_pet       = .TRUE.   !< Turn index PET (instant. input) on or off
+    LOGICAL ::  biom_pet_av    = .TRUE.   !< Turn index PET (averaged input) on or off
+    LOGICAL ::  biom_utci      = .TRUE.   !< Turn index UTCI (instant. input) on or off
+    LOGICAL ::  biom_utci_av   = .TRUE.   !< Turn index UTCI (averaged input) on or off
+
+!-- Add INTERFACES that must be available to other modules (alphabetical order)
+
+    PUBLIC biom_3d_data_averaging, biom_check_data_output,                     &
+    biom_calculate_static_grid, biom_calc_ipt,                                 &
+    biom_check_parameters, biom_data_output_3d, biom_data_output_2d,           &
+    biom_define_netcdf_grid, biom_determine_input_at, biom_header, biom_init,  &
+    biom_init_arrays, biom_parin, biom_pt, biom_pt_av, biom_pet, biom_pet_av,  &
+    biom_utci, biom_utci_av, time_biom_results
+
+!
+!-- PALM interfaces:
+!
+!-- 3D averaging for HTCM _INPUT_ variables
+    INTERFACE biom_3d_data_averaging
+       MODULE PROCEDURE biom_3d_data_averaging
+    END INTERFACE biom_3d_data_averaging
+
+!-- Calculate static thermal indices PT, UTCI and/or PET
+    INTERFACE biom_calculate_static_grid
+       MODULE PROCEDURE biom_calculate_static_grid
+    END INTERFACE biom_calculate_static_grid
+
+!-- Calculate the dynamic index iPT (to be caled by the agent model)
+    INTERFACE biom_calc_ipt
+       MODULE PROCEDURE biom_calc_ipt
+    END INTERFACE biom_calc_ipt
+
+!-- Data output checks for 2D/3D data to be done in check_parameters
+     INTERFACE biom_check_data_output
+        MODULE PROCEDURE biom_check_data_output
+     END INTERFACE biom_check_data_output
+
+!-- Input parameter checks to be done in check_parameters
+    INTERFACE biom_check_parameters
+       MODULE PROCEDURE biom_check_parameters
+    END INTERFACE biom_check_parameters
+
+!-- Data output of 2D quantities
+    INTERFACE biom_data_output_2d
+       MODULE PROCEDURE biom_data_output_2d
+    END INTERFACE biom_data_output_2d
+
+!-- no 3D data, thus, no averaging of 3D data, removed
+    INTERFACE biom_data_output_3d
+       MODULE PROCEDURE biom_data_output_3d
+    END INTERFACE biom_data_output_3d
+
+!-- Definition of data output quantities
+    INTERFACE biom_define_netcdf_grid
+       MODULE PROCEDURE biom_define_netcdf_grid
+    END INTERFACE biom_define_netcdf_grid
+
+!-- Obtains all relevant input values to estimate local thermal comfort/stress
+    INTERFACE biom_determine_input_at
+       MODULE PROCEDURE biom_determine_input_at
+    END INTERFACE biom_determine_input_at
+
+!-- Output of information to the header file
+    INTERFACE biom_header
+       MODULE PROCEDURE biom_header
+    END INTERFACE biom_header
+
+!-- Initialization actions 
+    INTERFACE biom_init
+       MODULE PROCEDURE biom_init
+    END INTERFACE biom_init
+
+!-- Initialization of arrays
+    INTERFACE biom_init_arrays
+       MODULE PROCEDURE biom_init_arrays
+    END INTERFACE biom_init_arrays
+
+!-- Reading of NAMELIST parameters
+    INTERFACE biom_parin
+       MODULE PROCEDURE biom_parin
+    END INTERFACE biom_parin
+
+ 
  CONTAINS
-
-
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Check data output for biometeorology model
-!------------------------------------------------------------------------------!
-    SUBROUTINE biometeorology_check_data_output( var, unit, i, ilen, k )
  
  
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sum up and time-average biom input quantities as well as allocate
+!> the array necessary for storing the average.
+!------------------------------------------------------------------------------!
+ SUBROUTINE biom_3d_data_averaging( mode, variable )
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  mode     !< 
+    CHARACTER (LEN=*) ::  variable !< 
+
+    INTEGER(iwp) ::  i  !< 
+    INTEGER(iwp) ::  j  !< 
+    INTEGER(iwp) ::  k  !< 
+
+
+    IF ( mode == 'allocate' )  THEN
+
+       SELECT CASE ( TRIM( variable ) )
+
+          CASE ( 'biom_mrt' )
+                IF ( .NOT. ALLOCATED( biom_mrt_av ) )  THEN
+                   ALLOCATE( biom_mrt_av(nmrtbl) )
+                ENDIF
+                biom_mrt_av = 0.0_wp
+
+          CASE ( 'biom_pt', 'biom_utci', 'biom_pet' )
+
+!--          Indices in unknown order as depending on input file, determine 
+!            first index to average und update only once
+             IF ( .NOT. average_trigger_pt .AND. .NOT. average_trigger_utci    &
+                .AND. .NOT. average_trigger_pet ) THEN
+                IF ( TRIM( variable ) == 'biom_pt' ) THEN
+                    average_trigger_pt = .TRUE.
+                ENDIF
+                IF ( TRIM( variable ) == 'biom_utci' ) THEN
+                    average_trigger_utci = .TRUE.
+                ENDIF
+                IF ( TRIM( variable ) == 'biom_pet' ) THEN
+                    average_trigger_pet = .TRUE.
+                ENDIF
+             ENDIF
+
+!--          Only continue if updateindex
+             IF ( average_trigger_pt   .AND. TRIM( variable ) /= 'biom_pt')   RETURN
+             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'biom_utci') RETURN
+             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'biom_pet')  RETURN
+
+!--          Set averaging switch to .TRUE. if not done by other module before!
+             IF ( .NOT. ALLOCATED( pt_av ) )  THEN
+                ALLOCATE( pt_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                aver_pt = .TRUE.
+             ENDIF
+             pt_av = 0.0_wp
+
+             IF ( .NOT. ALLOCATED( q_av ) )  THEN
+                ALLOCATE( q_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                aver_q = .TRUE.
+             ENDIF
+             q_av = 0.0_wp
+
+             IF ( .NOT. ALLOCATED( u_av ) )  THEN
+                ALLOCATE( u_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                aver_u = .TRUE.
+             ENDIF
+             u_av = 0.0_wp
+
+             IF ( .NOT. ALLOCATED( v_av ) )  THEN
+                ALLOCATE( v_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                aver_v = .TRUE.
+             ENDIF
+             v_av = 0.0_wp
+
+             IF ( .NOT. ALLOCATED( w_av ) )  THEN
+                ALLOCATE( w_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                aver_w = .TRUE.
+             ENDIF
+             w_av = 0.0_wp
+
+          CASE DEFAULT
+             CONTINUE
+
+       END SELECT
+
+    ELSEIF ( mode == 'sum' )  THEN
+
+       SELECT CASE ( TRIM( variable ) )
+
+          CASE ( 'biom_mrt' )
+             IF ( ALLOCATED( biom_mrt_av ) )  THEN
+
+                 IF ( nmrtbl > 0 )  THEN
+                    IF ( mrt_include_sw )  THEN
+                       biom_mrt_av(:) = biom_mrt_av(:) + &
+                          ((human_absorb*mrtinsw(:) + human_emiss*mrtinlw(:))  &
+                          / (human_emiss*sigma_sb)) ** .25_wp - cels_offs
+                    ELSE
+                       biom_mrt_av(:) = biom_mrt_av(:) + &
+                          (human_emiss * mrtinlw(:) / sigma_sb) ** .25_wp      &
+                          - cels_offs
+                    ENDIF
+                 ENDIF
+             ENDIF
+
+          CASE ( 'biom_pt', 'biom_utci', 'biom_pet' )
+
+!--          Only continue if updateindex
+             IF ( average_trigger_pt   .AND. TRIM( variable ) /= 'biom_pt')    &
+                RETURN
+             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'biom_utci')  &
+                RETURN
+             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'biom_pet')   &
+                RETURN
+
+             IF ( ALLOCATED( pt_av ) .AND. aver_pt ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( q_av )  .AND. aver_q ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         q_av(k,j,i) = q_av(k,j,i) + q(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( u_av )  .AND. aver_u ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         u_av(k,j,i) = u_av(k,j,i) + u(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( v_av )  .AND. aver_v ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         v_av(k,j,i) = v_av(k,j,i) + v(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( w_av )  .AND. aver_w ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         w_av(k,j,i) = w_av(k,j,i) + w(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+           CASE DEFAULT
+             CONTINUE
+
+       END SELECT
+
+    ELSEIF ( mode == 'average' )  THEN
+
+       SELECT CASE ( TRIM( variable ) )
+
+          CASE ( 'biom_mrt' )
+             IF ( ALLOCATED( biom_mrt_av ) )  THEN
+                biom_mrt_av(:) = biom_mrt_av(:) / REAL( average_count_3d, KIND=wp )
+             ENDIF
+
+          CASE ( 'biom_pt', 'biom_utci', 'biom_pet' )
+
+!--          Only continue if update index
+             IF ( average_trigger_pt   .AND. TRIM( variable ) /= 'biom_pt')    &
+                RETURN
+             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'biom_utci')  &
+                RETURN
+             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'biom_pet')   &
+                RETURN
+
+             IF ( ALLOCATED( pt_av ) .AND. aver_pt ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( q_av ) .AND. aver_q ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( u_av ) .AND. aver_u ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( v_av ) .AND. aver_v ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( ALLOCATED( w_av ) .AND. aver_w ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+!--          Udate thermal indices with derived averages
+             CALL biom_calculate_static_grid ( .TRUE. )
+
+        END SELECT
+
+    ENDIF
+
+
+ END SUBROUTINE biom_3d_data_averaging
+
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Check data output for biometeorology model
+!------------------------------------------------------------------------------!
+ SUBROUTINE biom_check_data_output( var, unit )
+
        USE control_parameters,                                                 &
            ONLY: data_output, message_string
@@ -119,48 +480,73 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  unit     !< 
-       CHARACTER (LEN=*) ::  var      !<
-
-       INTEGER(iwp) :: i
-       INTEGER(iwp) :: ilen
-       INTEGER(iwp) :: k
-
-       SELECT CASE ( TRIM( var ) )
-
-          CASE ( 'bio_mrt', 'bio_pet'  )
-             IF ( .NOT.  radiation ) THEN
-                message_string = 'output of "' // TRIM( var ) // '" require'&
-                                 // 's radiation = .TRUE.'
-                CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( mrt_nlevels == 0 ) THEN
-                message_string = 'output of "' // TRIM( var ) // '" require'&
-                                 // 's mrt_nlevels > 0'
-                CALL message( 'check_parameters', 'PA0510', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'bio_mrt' ) THEN
-                unit = 'K'
-             ELSE
-                unit = 'W m-2'
-             ENDIF
-
-          CASE DEFAULT
-             unit = 'illegal'
-
-       END SELECT
-
-    END SUBROUTINE biometeorology_check_data_output
-
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine for averaging 3D data
-!------------------------------------------------------------------------------!
-SUBROUTINE biometeorology_3d_data_averaging( mode, variable )
-
-    USE control_parameters
+       CHARACTER (LEN=*) ::  unit     !< The unit for the variable var
+       CHARACTER (LEN=*) ::  var      !< The variable in question
+
+
+                unit = 'Â°C'
+                IF ( .NOT. biometeorology ) THEN
+                  message_string = 'output of "' // TRIM( var ) // '" req' //  &
+                        'uires biometeorology = .TRUE. in initialisati' &
+                        // 'on_parameters'
+                  CALL message( 'check_parameters', 'PA0114', 1, 2, 0, 6, 0 )
+                  unit = 'illegal'
+                ENDIF
+                IF ( .NOT.  radiation ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's radiation = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
+                   unit = 'illegal'
+                ENDIF
+                IF ( mrt_nlevels == 0 ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's mrt_nlevels > 0'
+                   CALL message( 'check_parameters', 'PA0510', 1, 2, 0, 6, 0 )
+                   unit = 'illegal'
+                ENDIF
+
+ END SUBROUTINE biom_check_data_output
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Check parameters routine for biom module
+!> check_parameters 1302
+!------------------------------------------------------------------------------!
+ SUBROUTINE biom_check_parameters
+
+    USE control_parameters,                                                    &
+        ONLY:  message_string
+
+
+    IMPLICIT NONE
+
+
+!--    Disabled as long as radiation model not available
+       IF ( .NOT. radiation )  THEN
+          message_string = 'The human thermal comfort module does require ' // &
+                           'radiation information in terms of the mean ' //    &
+                           'radiant temperature, but radiation is not enabled!'
+          CALL message( 'check_parameters', 'PAHU01', 0, 0, 0, 6, 0 )
+       ENDIF
+
+       IF ( .NOT. humidity )  THEN
+          message_string = 'The human thermal comfort module does require ' // &
+                           'air humidity information, but humidity module ' // &
+                           'is disabled!'
+          CALL message( 'check_parameters', 'PAHU02', 0, 0, 0, 6, 0 )
+       ENDIF
+
+
+ END SUBROUTINE biom_check_parameters
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining 3D output variables (dummy, always 2d!)
+!> data_output_3d 709ff
+!------------------------------------------------------------------------------!
+ SUBROUTINE biom_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
 
     USE indices
